<?php
// Business Process Addons COMPONENT
//
// Copyright (c) 2010 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: bpa.inc.php 73 2010-07-26 20:44:23Z mguthrie $

require_once(dirname(__FILE__).'/../componenthelper.inc.php');

// respect the name
$bpa_component_name="Business Process Addons";

// run the initialization function
bpa_component_init();

////////////////////////////////////////////////////////////////////////
// COMPONENT INIT FUNCTIONS
////////////////////////////////////////////////////////////////////////

function bpa_component_init(){
	global $bpa_component_name;
	
	$versionok=bpa_component_checkversion();
	
	$desc="This component brings the Business Process Addons into the XI Home menu";
	if(!$versionok)
		$desc="<b>Error: This component requires Nagios XI 2009R1.2B or later.</b>";
	
	$args=array(

		// need a name
		COMPONENT_NAME => $bpa_component_name,
		
		// informative information
		COMPONENT_AUTHOR => "Nagios Enterprises, LLC",
		COMPONENT_DESCRIPTION => 'Business Process Addons. '.$desc,
		COMPONENT_TITLE => "Business Process Addons",

		
		);
		
	register_component($bpa_component_name,$args);
	
	// add a menu link
	if($versionok)
		register_callback(CALLBACK_MENUS_INITIALIZED,'bpa_component_addmenu');
	}
	



///////////////////////////////////////////////////////////////////////////////////////////
// MISC FUNCTIONS
///////////////////////////////////////////////////////////////////////////////////////////

function bpa_component_checkversion(){

	if(!function_exists('get_product_release'))
		return false;
	//requires greater than 2009R1.2
	if(get_product_release()<114)
		return false;

	return true;
	}
	
function bpa_component_addmenu($arg=null)
{
	global $bpa_component_name;
	
	//$base_url = get_base_url();
	//$base = substr($base_url, 0, (strlen($base_url)-3) ) ; //chop down url
	 
	//$mi=find_menu_item(MENU_HOME,"menu-home-networkstatusmap","id");
	$mi=find_menu_item(MENU_HOME,"menu-home-servicegroupgrid","id");
	if($mi==null)
		return;
		
	$order=grab_array_var($mi,"order","");
	if($order=="")
		return;
		
	$neworder=$order+0.1;

	//get server web address 
	if(isset($_SERVER['SERVER_NAME']) )
	{
		$address = $_SERVER['SERVER_NAME'];
	}
	elseif(isset($_SERVER['SERVER_ADDR']) )
	{
		$address = $_SERVER['SERVER_ADDR'];
	}
	else {} //do nothing 
	
	if(isset($address))
	{
	
		add_menu_item(MENU_HOME,array(
			"type" => "linkspacer",
			"title" => "",
			"id" => "menu-home-bpa_spacer",
			"order" => $neworder,
			"opts" => array()
			));
	
		$neworder=$neworder+0.1;
		add_menu_item(MENU_HOME,array(
			"type" => "link",
			"title" => "Business Process View",
			"id" => "menu-home-bpav",
			"order" => $neworder,
			"opts" => array(
				"href" => 'http://'.$address.'/nagiosbp/cgi-bin/nagios-bp.cgi',
				)
			));

		$neworder=$neworder+0.1;
		add_menu_item(MENU_HOME,array(
			"type" => "link",
			"title" => "Business Process Impact",
			"id" => "menu-home-bpai",
			"order" => $neworder,
			"opts" => array(
				"href" => 'http://'.$address.'/nagiosbp/cgi-bin/nagios-bp.cgi?mode=bi',
				)
			));	
	
	

			

	
	}	
		
	
}


?>